diff -rupN /usr/src/linux-2.4.9/include/linux/aio.h linux/include/linux/aio.h
--- /usr/src/linux-2.4.9/include/linux/aio.h	Thu Jan  1 03:00:00 1970
+++ linux/include/linux/aio.h	Sun Aug 26 01:10:10 2001
@@ -0,0 +1,322 @@
+#ifndef _LINUX_AIO_H
+#define _LINUX_AIO_H
+/*
+ * A kernel implementation of POSIX Asynchronous I/O facility (KAIO).
+ *
+ * Copyright 1999, Silicon Graphics, Inc.
+ *
+ * Written October 1999 by Rajagopal Ananthanarayanan (ananth)
+ *  			at Silicon Graphics, Inc.
+ */
+
+/*
+ * User code gets access to AIO by simply including this header file.
+ * CONFIG_AIO has to be explicitly turned on for the kernel.
+ */
+
+#ifndef __KERNEL__
+#define CONFIG_AIO
+#endif
+
+#if defined(CONFIG_AIO)
+
+#ifdef __KERNEL__
+#include <asm/siginfo.h>
+#else
+#include <sys/types.h> 		/* off_t, etc. 				*/
+#include <signal.h>		/* sigevent_t, etc. 			*/
+#endif
+
+/*
+ * Default & maximum number of threads to be used for processing
+ * parts of aio request. Number of threads can be changed using the
+ * environment variable below.
+ */
+
+#define AIO_THREAD_ENVIRON	"AIO_NTHREADS"
+#define AIO_DEFAULT_THREADS 	 4
+/* #define AIO_MAX_THREADS		64 */
+#define AIO_MAX_THREADS		(1024-100)
+
+#define AIO_TIMES	8
+#define AIO_RESERVED	4
+
+#define KAIO_STATS
+
+/*
+ * User code can turn on 64-bit offsets in aiocb by:
+ * 	#define _FILE_OFFSET_BITS 64
+ *	#include <features.h>
+ *	#include <linux/aio.h>
+ * which will turn all aio_*() interfaces to operate with 64-bit offsets.
+ * 
+ * Further, #define _LARGEFILE64_SOURCE will enable LFS style aio_*64()
+ * interfaces. Important note: <features.h> should be included as
+ * the first file in a code module, for the above to work correctly.
+ * See <features.h> for further details.
+ *
+ * An alternate way to turn on 64-bit offsets in aiocb is to:
+ *	#define AIO_FILE_OFFSET64
+ *	#include <linux/aio.h>
+ * Similarly LFS interfaces can be enabled by:
+ *	#define AIO_LARGEFILE64
+ *	#include <linux/aio.h>
+ * 
+ * The kernel always uses 64-bit offset values. If user code does not
+ * enable 64-bit offsets, the library will suitably zero out the padding.
+ */
+typedef struct aiocb {
+	int		aio_fildes;	/* File descriptor to perform aio  */ 
+	void		*aio_buf;	/* User's data buffer 		   */
+	size_t		aio_nbytes;	/* No. of bytes in transfer 	   */
+#if defined(__USE_FILE_OFFSET64) || defined(AIO_FILE_OFFSET64) || defined(__KERNEL__)
+	loff_t		aio_offset;
+#else
+	off_t		aio_offset;	/* File position to begin transfer */
+	char		__aio_pad[sizeof(loff_t) - sizeof(off_t)];
+#endif
+	int		aio_reqprio;	/* Unused - Reserved 		   */
+	sigevent_t	aio_sigevent;	/* Notification Options 	   */
+	int		aio_lio_opcode; /* lio_listio opcode 		   */
+	unsigned long	aio_reserved[AIO_RESERVED];/* Don't use this 		   */
+#ifdef KAIO_STATS
+	unsigned long	aio_times[AIO_TIMES];
+#endif
+} aiocb_t;
+
+
+#if defined(__USE_LARGEFILE64) || defined(AIO_LARGEFILE64)
+typedef struct aiocb64 {
+	int		aio_fildes;	/* File descriptor to perform aio  */ 
+	void		*aio_buf;	/* User's data buffer 		   */
+	size_t		aio_nbytes;	/* No. of bytes in transfer 	   */
+	loff_t		aio_offset;	/* File offset - 64 bits	   */
+	int		aio_reqprio;	/* Unused - Reserved 		   */
+	sigevent_t	aio_sigevent;	/* Notification Options 	   */
+	int		aio_lio_opcode; /* lio_listio opcode 		   */
+	unsigned long	aio_reserved[AIO_RESERVED];/* Don't use this 		   */
+#ifdef KAIO_STATS
+	unsigned long	aio_times[AIO_TIMES];
+#endif
+} aiocb64_t;
+#endif
+
+/*
+ * Internal to the aio library
+ */
+#define AIOCMD_READ		1
+#define AIOCMD_SUSPEND		2
+#define AIOCMD_CANCEL		3
+#define AIOCMD_RETURN		4
+#define AIOCMD_PCINVALIDATE	5	/* invalidate page cache	   */
+#define AIOCMD_SLAVE		6	/* put a slave in wait for request */
+#define AIOCMD_WRITE		7
+#define AIOCMD_GENERIC_READ	8 	/* Reserved for internal use	   */
+#define AIOCMD_LIST_IO		9
+#define AIOCMD_IOCTL            10
+#define AIOCMD_CLOSE            11
+
+/*
+ * For gathering timing statistics.
+ */
+/*
+#define AIOTIME_REQUEST		0
+#define AIOTIME_IO		1
+#define AIOTIME_COPY		2
+*/
+#define AIOTIME_REQUEST         0 /* (userspace) before aio_* */
+#define AIOTIME_ENQUEUED        1 /* kaiocb created */
+#define AIOTIME_DEQUEUED        2 /* request dequeued by a slave */
+#define AIOTIME_IO              3 /* i/o finished */
+#define AIOTIME_COPY            4 /* copying to userspace finshed */
+#define AIOTIME_COMPLETE        6 /* in kaio_io_complete */
+#define AIOTIME_FINISH          7 /* (userspace) noticed op completion */
+
+#if !defined(__USE_FILE_OFFSET64) && !defined(AIO_FILE_OFFSET64)
+/*
+ * Procedural interfaces.
+ */
+int 	aio_read(struct aiocb *aiocbp);
+int 	aio_write(struct aiocb *aiocbp);
+ssize_t	aio_return(struct aiocb *aiocbp);
+int	aio_cancel(int fildes, struct aiocb *aiocbp);
+int	aio_fsync(int op, struct aiocb *aiocbp);
+int	aio_suspend(const struct aiocb *const list[],
+			 int nent, const struct timespec *timeout);
+int 	lio_listio(int mode, struct aiocb *const list[],
+			int nent, struct sigevent *sig);
+int     aio_ioctl(struct aiocb *aiocbp);
+int     aio_close(struct aiocb *aiocbp);
+#else
+# ifdef __REDIRECT
+extern int __REDIRECT (aio_read, __P ((struct aiocb *__aiocbp)), aio_read64);
+extern int __REDIRECT (aio_write, __P ((struct aiocb *__aiocbp)), aio_write64);
+extern int __REDIRECT (lio_listio, __P ((int __mode,
+		     struct aiocb *__const __restrict __list[],
+		     int __nent, struct sigevent *__restrict __sig)), lio_listio64);
+extern __ssize_t __REDIRECT (aio_return, __P ((struct aiocb *__aiocbp)), aio_return64);
+extern int __REDIRECT (aio_cancel, __P ((int __fildes, struct aiocb *__aiocbp)),
+		       aio_cancel64);
+extern int __REDIRECT (aio_suspend,
+		       __P ((__const struct aiocb *__const __restrict __list[],
+			     int __nent,
+			     __const struct timespec *__restrict __timeout)),
+		       aio_suspend64);
+#else
+#define aio_read aio_read64
+#define aio_write aio_write64
+#define lio_listio lio_listio64
+#define aio_return aio_return64
+#define aio_cancel aio_cancel64
+#define aio_suspend aio_suspend64
+#endif
+#endif
+
+#define aio_error(a)	(volatile int)(a)->aio_reserved[2]
+/*
+ * 64-bit interfaces.
+ */
+#if defined(__USE_LARGEFILE64) || defined(AIO_LARGEFILE64)
+int 	aio_read64(struct aiocb64 *aiocbp);
+int 	aio_write64(struct aiocb64 *aiocbp);
+ssize_t	aio_return64(struct aiocb64 *aiocbp);
+int	aio_cancel64(int fildes, struct aiocb64 *aiocbp);
+int	aio_fsync64(int op, struct aiocb64 *aiocbp);
+#define aio_error64(a)	aio_error(a)
+int	aio_suspend64(const struct aiocb64 *const list[],
+			 int nent, const struct timespec *timeout);
+int 	lio_listio64(int mode, struct aiocb64 *const list[],
+			int nent, struct sigevent *sig);
+int     aio_ioctl64(struct aiocb64 *aiocbp);
+int     aio_close64(struct aiocb64 *aiocbp);
+#endif
+
+/*
+ * Return values for aio_cancel.
+ */
+#define AIO_CANCELED		1
+#define AIO_NOTCANCELED		2
+#define AIO_ALLDONE		3
+
+/*
+ * Listio modes
+ */
+#define LIO_WAIT		1
+#define LIO_NOWAIT		2
+
+
+/*
+ * Listio opcodes
+ */
+#define LIO_READ		1
+#define LIO_WRITE		2
+#define LIO_NOP			3
+
+#ifdef __KERNEL__
+
+#if defined(CONFIG_RAW)
+#include <linux/iobuf.h>
+/*
+ * Interfaces expected from Raw I/O for AIO.
+ */
+extern	int kaio_is_raw(struct file *);
+extern	int kaio_raw_wait(void *, struct kiobuf *);
+extern	void *kaio_raw_rw(int, struct file *, char *, size_t, loff_t *, 
+			  int *, struct semaphore *, struct kiobuf *);
+#endif
+
+typedef struct liocb {
+	spinlock_t 	 lio_lock; 	/* protects nent manipulation	   */
+	int	   	 lio_nent; 	/* number of kaio's being awaited  */
+	int	   	 lio_done; 	/* number of kaio's completed	   */
+	wait_queue_head_t lio_wait;	/* wait here for completion of lio */
+	struct sigevent	   lio_sigevent;/* completeion signal info, if any */
+	struct task_struct *lio_task;	/* requesting task		   */
+	int		 lio_mode;	/* mode used in request 	   */
+} liocb_t;
+
+typedef struct kaiocb {
+
+	struct file	*kaio_filp;	/* held by an fget() 		*/
+	void		*kaio_buf;	/* user's data buffer */
+	size_t		kaio_nbytes;
+	aiocb_t		*kaio_uaiocb; /* user aiocb for this request  */
+
+	/* 0x10 */
+	loff_t		kaio_offset;
+	int 		kaio_cmd;	/* read / write 		*/
+	int		kaio_error;
+
+	/* 0x20 */
+	int		kaio_id;	/* unique id for this kaiocb	*/
+	struct kaiocb	*kaio_h_next;	/* hash table pointer		*/
+	struct kaiocb	**kaio_h_pprev;	/* hash table pointer		*/
+	struct page 	**kaio_pages;	/* list of kernel pages   	*/
+
+	/* 0x30 */
+	int		kaio_npages; 	/* no. of kernel pages 	  	*/
+	liocb_t		*kaio_liocb; 	/* List I/O control block pointer */
+	wait_queue_head_t *kaio_suspend_wait;	/* wait here on kaio_suspend */
+	struct page 	*kaio_page_inline; /* one page optimization	*/
+
+	/* 0x40 */
+	struct list_head   kaio_ioq;	/* pointers for queueing aio 	*/
+	struct task_struct *kaio_task;	/* requesting task		*/
+	void		   *kaio_kq;	/* kaioq  of requesting task	*/
+
+	/* 0x50 */
+	sigevent_t	kaio_sigevent;	/* Notification Options		*/
+
+#if defined(CONFIG_RAW)
+	/* RAW I/O fields */
+	struct semaphore kaio_sem;	/* for use by raw I/O		*/
+	struct kiobuf 	 kaio_iobuf; 	/* for use by raw I/O		*/
+	void 		 *kaio_scp;	/* cookie returned by raw I/O   */
+#endif
+
+        int             kaio_fd;        /* original fd, for AIOCMD_<syscall> */
+
+#ifdef KAIO_STATS
+	unsigned long	kaio_times[AIO_TIMES];
+#define kaio_set_time(k, x) 	(k)->kaio_times[(x)] = kaio_time()
+#else
+#define kaio_set_time(k, x)
+#endif /* KAIO_STATS */
+
+} kaiocb_t;
+
+
+typedef struct kaio_key {
+	int	kaio_kid;
+	void	*kaio_kq;
+} kaio_key_t;
+
+
+#define aio_key		aio_reserved[0]
+/* 	aio_key[1]	aio_reserved[1] */
+
+#undef aio_error	/* don't want user definition which is a function */
+#define aio_error	aio_reserved[2]
+#define aio_return	aio_reserved[3]
+
+extern int kaio_rw(int cmd, struct aiocb *, liocb_t *);
+extern int kaio_syscall(int cmd, struct aiocb *);
+extern int kaio_list_io(int, struct aiocb *[], int, sigevent_t *);
+extern int kaio_suspend(aiocb_t *[], int, struct timespec *, int);
+extern int kaio_cancel(int, kaio_key_t *);
+extern void kaio_init(void);
+extern void kaio_slave(void);
+extern void kaio_q_create(struct task_struct *);
+
+
+/*
+ * Prefix for the names of slave threads
+ */
+#define KAIO_SLAVE_NAME		"kaiod-"
+#define KAIO_SLAVE_NAMELEN	6
+
+#endif /* __KERNEL__ */
+
+#endif /* CONFIG_AIO */
+
+#endif /* _LINUX_AIO_H */
diff -rupN /usr/src/linux-2.4.9/include/linux/reiserfs_fs.h linux/include/linux/reiserfs_fs.h
--- /usr/src/linux-2.4.9/include/linux/reiserfs_fs.h	Fri Aug 24 01:36:23 2001
+++ linux/include/linux/reiserfs_fs.h	Sun Aug 26 01:20:40 2001
@@ -118,6 +118,7 @@
 #define REISERFS_SUPER_MAGIC_STRING "ReIsErFs"
 #define REISER2FS_SUPER_MAGIC_STRING "ReIsEr2Fs"
 
+#ifdef __KERNEL__
 static inline int is_reiserfs_magic_string (struct reiserfs_super_block * rs)
 {
     return (!strncmp (rs->s_magic, REISERFS_SUPER_MAGIC_STRING, 
@@ -125,6 +126,7 @@ static inline int is_reiserfs_magic_stri
 	    !strncmp (rs->s_magic, REISER2FS_SUPER_MAGIC_STRING, 
 		      strlen ( REISER2FS_SUPER_MAGIC_STRING)));
 }
+#endif /* __KERNEL__ */
 
 				/* ReiserFS leaves the first 64k unused,
                                    so that partition labels have enough
@@ -466,7 +468,7 @@ static inline __u32 type2uniqueness (int
     return V1_ANY_UNIQUENESS;
 }
 
-
+#ifdef __KERNEL__
 //
 // key is pointer to on disk key which is stored in le, result is cpu,
 // there is no way to get version of object from key, so, provide
@@ -530,7 +532,7 @@ static inline void set_le_ih_k_type (str
 #define is_indirect_le_ih(ih) is_indirect_le_key (ih_version(ih), &((ih)->ih_key))
 #define is_statdata_le_ih(ih) is_statdata_le_key (ih_version (ih), &((ih)->ih_key))
 
-
+#endif /* __KERNEL__ */
 
 //
 // key is pointer to cpu key, result is cpu
@@ -722,6 +724,8 @@ struct stat_data {
 				       based on sd_size and our tail
 				       suppression policy? */
   } __attribute__ ((__packed__)) u;
+    int more[0];                /* reference point for extensions
+                                   like raw attributes below */
 } __attribute__ ((__packed__));
 //
 // this is 40 bytes long
@@ -730,6 +734,25 @@ struct stat_data {
 
 #define stat_data_v1(ih) (ih_version (ih) == ITEM_VERSION_1)
 
+/*
+ * Reiserfs-raw keeps its extra attributes in stat data.  There is no
+ * place for them in struct stat_data, and I don't want to add
+ * additional fields to the disk structure -- normal files don't need
+ * these extra attributes, so we use the following trick.  For raw
+ * files, we create enlargened SD item, and keep our attribute values
+ * just after stat data structure.  Here are macros to access them.
+ * Remember they are in le32 layout.
+ */
+struct raw_attr {
+    __u32 lastref;
+    __u32 expires;
+    __u32 user1;
+};
+#define ATTR_LASTREF(SD)        (((struct raw_attr *)(SD)->more)->lastref)
+#define ATTR_EXPIRES(SD)        (((struct raw_attr *)(SD)->more)->expires)
+#define ATTR_USER1(SD)          (((struct raw_attr *)(SD)->more)->user1)
+#define RAW_SD_SIZE             (sizeof(struct stat_data) + \
+                                 sizeof(struct raw_attr))
 
 /***************************************************************************/
 /*                      DIRECTORY STRUCTURE                                */
@@ -826,6 +849,7 @@ struct reiserfs_de_head
 #define de_visible(deh)	    	    test_bit_unaligned (DEH_Visible, &((deh)->deh_state))
 #define de_hidden(deh)	    	    !test_bit_unaligned (DEH_Visible, &((deh)->deh_state))
 
+#ifdef __KERNEL__
 /* compose directory item containing "." and ".." entries (entries are
    not aligned to 4 byte boundary) */
 static inline void make_empty_dir_item_v1 (char * body, __u32 dirid, __u32 objid,
@@ -932,7 +956,7 @@ static inline int entry_length (struct b
 // two entries per block (at least)
 #define REISERFS_MAX_NAME_LEN(block_size) 255
 
-
+#endif /* __KERNEL__ */
 
 
 /* this structure is used for operations on directory entries. It is
@@ -1135,6 +1159,7 @@ struct path var = {ILLEGAL_PATH_ELEMENT_
 
 ///#define TOO_LONG_LENGTH		(~0ULL)
 
+#ifdef __KERNEL__
 // reiserfs version 2 has max offset 60 bits. Version 1 - 32 bit offset
 #define U32_MAX (~(__u32)0)
 static inline loff_t max_reiserfs_offset (struct inode * inode)
@@ -1144,7 +1169,7 @@ static inline loff_t max_reiserfs_offset
 
     return (loff_t)((~(__u64)0) >> 4);
 }
-
+#endif /* __KERNEL__ */
 
 /*#define MAX_KEY_UNIQUENESS	MAX_UL_INT*/
 #define MAX_KEY_OBJECTID	MAX_UL_INT
@@ -1397,6 +1422,7 @@ struct buffer_info {
 +-------------------+------------+--------------+------------+
 */
 
+#ifdef __KERNEL__ 
 struct item_operations {
     int (*bytes_number) (struct item_head * ih, int block_size);
     void (*decrement_key) (struct cpu_key *);
@@ -1430,7 +1456,7 @@ extern struct item_operations * item_ops
 #define op_unit_num(vi)				     item_ops[(vi)->vi_index]->unit_num (vi)
 #define op_print_vi(vi)                              item_ops[(vi)->vi_index]->print_vi (vi)
 
-
+#endif /* __KERNEL__ */
 
 
 
@@ -1544,9 +1570,10 @@ struct reiserfs_journal_header {
   __u32 j_first_unflushed_offset ;      /* offset in the log of where to start replay after a crash */
   __u32 j_mount_id ;
 } ;
-
+#ifdef __KERNEL__
 extern task_queue reiserfs_commit_thread_tq ;
 extern wait_queue_head_t reiserfs_commit_thread_wait ;
+#endif /* __KERNEL__ */
 
 /* biggest tunable defines are right here */
 #define JOURNAL_BLOCK_COUNT 8192 /* number of blocks in the journal */
@@ -1580,6 +1607,7 @@ extern wait_queue_head_t reiserfs_commit
 */
 #define JOURNAL_BUFFER(j,n) ((j)->j_ap_blocks[((j)->j_start + (n)) % JOURNAL_BLOCK_COUNT])
 
+#ifdef __KERNEL__
 void reiserfs_wait_on_write_block(struct super_block *s) ;
 void reiserfs_block_writes(struct reiserfs_transaction_handle *th) ;
 void reiserfs_allow_writes(struct super_block *s) ;
@@ -1773,12 +1801,15 @@ int reiserfs_prepare_write(struct file *
 void reiserfs_truncate_file(struct inode *, int update_timestamps) ;
 void make_cpu_key (struct cpu_key * cpu_key, const struct inode * inode, loff_t offset,
 		   int type, int key_length);
+void _make_cpu_key (struct cpu_key * key, int version, __u32 dirid, __u32 objectid, 
+                    loff_t offset, int type, int length);
 void make_le_item_head (struct item_head * ih, struct cpu_key * key, int version,
 			       loff_t offset, int type, int length, int entry_count);
 /*void store_key (struct key * key);
 void forget_key (struct key * key);*/
 int reiserfs_get_block (struct inode * inode, long block,
 			struct buffer_head * bh_result, int create);
+void inode2sd (void * sd, struct inode * inode);
 struct inode * reiserfs_iget (struct super_block * s, struct cpu_key * key);
 void reiserfs_read_inode (struct inode * inode) ;
 void reiserfs_read_inode2(struct inode * inode, void *p) ;
@@ -1944,6 +1975,47 @@ __u32 r5_hash (const char *msg, int len)
 
 /* version.c */
 char *reiserfs_get_version_string(void) ;
+#endif /* __KERNEL__ */
+
+/* raw.c */
+struct reiserfs_raw_ioctl_arg {
+    __u32 id1;          /* object id of the obj to operate on (low part) */
+    __u32 id2;          /* object id of the obj to operate on (high part) */
+    __u32 lastref;      /* last reference date (a la atime) */
+    __u32 expires;      /* expiration date */
+    __u32 user1;        /* user attribute, not used by the kernel */
+    loff_t size;        /* file size returned by RAWOPEN */
+};
+
+struct reiserfs_sigtimedwait_arg {
+  sigset_t        *uthese;
+  size_t           sigsetsize;
+  siginfo_t       *uinfo; 
+  size_t           uinfos;
+  struct timespec *uts;
+};
+
+#ifdef __KERNEL__
+int reiserfs_rawopen (struct inode *, struct vfsmount *, struct reiserfs_raw_ioctl_arg *);
+int reiserfs_rawcreat (struct inode *, struct vfsmount *, struct reiserfs_raw_ioctl_arg *);
+int reiserfs_rawsetattr (struct inode *, struct reiserfs_raw_ioctl_arg *);
+int reiserfs_rawsetattr_f (struct inode *, struct reiserfs_raw_ioctl_arg *);
+int reiserfs_rawsetattr2 (struct inode *, struct reiserfs_raw_ioctl_arg *);
+int reiserfs_rawunlink (struct inode *, struct reiserfs_raw_ioctl_arg *);
+int reiserfs_rawunlink2 (struct inode *);
+int reiserfs_sigtimedwait(struct inode *, struct reiserfs_sigtimedwait_arg *);
+
+/* pgc.c */
+int  pgc_init (struct super_block *sb);
+void pgc_cleanup (struct super_block *, struct reiserfs_transaction_handle *);
+void pgc_set_thresholds (struct super_block *, int, int);
+void pgc_scan_buffer (struct super_block *sb, struct buffer_head *bh);
+void pgc_age_class_update (struct reiserfs_transaction_handle *th,
+                           time_t old_lastref, time_t new_lastref);
+void pgc_process_unlinkq (struct super_block *sb);
+time_t pgc_current_time (struct super_block *sb);
+
+#endif /*__KERNEL__*/
 
 /* the ext2 bit routines adjust for big or little endian as
 ** appropriate for the arch, so in our laziness we use them rather
@@ -2039,6 +2111,7 @@ found_middle:
    absolutely safe */
 #define SPARE_SPACE 500
 
+#ifdef __KERNEL__
 static inline unsigned long reiserfs_get_journal_block(struct super_block *s) {
     return le32_to_cpu(SB_DISK_SUPER_BLOCK(s)->s_journal_block) ;
 }
@@ -2050,10 +2123,18 @@ static inline unsigned long reiserfs_get
 int reiserfs_ioctl (struct inode * inode, struct file * filp, 
  		    unsigned int cmd, unsigned long arg);
 int reiserfs_unpack (struct inode * inode, struct file * filp);
- 
+int reiserfs_dir_ioctl (struct inode * inode, struct file * filp, 
+                        unsigned int cmd, unsigned long arg);
+#endif /* __KERNEL__ */
+
 /* ioctl's command */
 #define REISERFS_IOC_UNPACK		_IOW(0xCD,1,long)
- 			         
+#define REISERFS_IOC_RAWOPEN           _IOWR(0xCD,15,sizeof(struct reiserfs_raw_ioctl_arg))
+#define REISERFS_IOC_RAWCREAT           _IOW(0xCD,16,sizeof(struct reiserfs_raw_ioctl_arg))
+#define REISERFS_IOC_RAWSETATTR         _IOW(0xCD,17,sizeof(struct reiserfs_raw_ioctl_arg))
+#define REISERFS_IOC_RAWUNLINK          _IOW(0xCD,18,sizeof(struct reiserfs_raw_ioctl_arg))
+#define REISERFS_IOC_TIMEDWAIT          _IOW(0xCD,19,sizeof(struct reiserfs_sigtimedwait_arg))
+
 #endif /* _LINUX_REISER_FS_H */
 
 
diff -rupN /usr/src/linux-2.4.9/include/linux/reiserfs_fs_i.h linux/include/linux/reiserfs_fs_i.h
--- /usr/src/linux-2.4.9/include/linux/reiserfs_fs_i.h	Sat Jul 21 20:20:58 2001
+++ linux/include/linux/reiserfs_fs_i.h	Sat Aug 25 17:39:03 2001
@@ -40,6 +40,35 @@ struct reiserfs_inode_info {
                                    is a comment you should make.... -Hans */
   //nopack-attribute
   int nopack;
+
+  /* reiserfs_raw attributes */
+  __u32 lastref;                /* the time the file was last
+                                   referenced (created or open). This
+                                   is used for garbage collection, so
+                                   we don't need precise timestamping
+                                   -- all timestamps that fit in one
+                                   age class can be considered the
+                                   same. So we use coarse-grained
+                                   timestamp provided by
+                                   pgc_current_time() to avoid
+                                   excessive timestamp updates when
+                                   the file is accessed frequently. In
+                                   other words, we avoid updating
+                                   timestamps unless the update would
+                                   result in moving the file into
+                                   another age class. */
+  __u32 expires;                /* expiration date -- may be set by
+                                   application to request removal of
+                                   the file by PGC even if the lastref
+                                   isn't old enough to indicate it
+                                   should be targeted for removal
+                                   lastref-wise */
+  __u32 user1;                  /* an opaque attribute for application
+                                   use: the kernel only stores and
+                                   retrieves it, but never looks at
+                                   its value.  In the case of squid it
+                                   may someday hold the length of the
+                                   header.  */
 };
 
 
diff -rupN /usr/src/linux-2.4.9/include/linux/reiserfs_fs_sb.h linux/include/linux/reiserfs_fs_sb.h
--- /usr/src/linux-2.4.9/include/linux/reiserfs_fs_sb.h	Fri Aug 24 00:23:40 2001
+++ linux/include/linux/reiserfs_fs_sb.h	Sun Aug 26 01:06:26 2001
@@ -6,6 +6,7 @@
 
 #ifdef __KERNEL__
 #include <linux/tqueue.h>
+#include <linux/age_class.h>
 #endif
 
 //
@@ -302,6 +303,9 @@ struct reiserfs_sb_info
     int s_bmaps_without_search;
     int s_direct2indirect;
     int s_indirect2direct;
+#ifdef CONFIG_REISERFS_RAW
+    struct pgc *pgc;
+#endif
 };
 
 
@@ -327,6 +331,13 @@ struct reiserfs_sb_info
 #define FORCE_R5_HASH 8       /* try to force rupasov hash on mount */
 #define FORCE_HASH_DETECT 9   /* try to detect hash function on mount */
 
+/* -o raw: enable ioctl (REISERFS_IOC_RAW*) which provides raw access
+   to internal reiserfs tree.  This is designed for squid proxy cache
+   acceleration.  To use this, recompile the kernel with
+   CONFIG_REISERFS_RAW enabled. */
+
+#define REISERFS_RAW 10
+
 
 /* used for testing experimental features, makes benchmarking new
    features with and without more convenient, should never be used by
@@ -355,7 +366,7 @@ struct reiserfs_sb_info
 #define replay_only(s) ((s)->u.reiserfs_sb.s_mount_opt & (1 << REPLAYONLY))
 #define reiserfs_dont_log(s) ((s)->u.reiserfs_sb.s_mount_opt & (1 << REISERFS_NOLOG))
 #define old_format_only(s) ((SB_VERSION(s) != REISERFS_VERSION_2) && !((s)->u.reiserfs_sb.s_mount_opt & (1 << REISERFS_CONVERT)))
-
+#define reiserfs_raw(s) ((s)->u.reiserfs_sb.s_mount_opt & (1 << REISERFS_RAW))
 
 void reiserfs_file_buffer (struct buffer_head * bh, int list);
 int reiserfs_is_super(struct super_block *s)  ;
diff -rupN /usr/src/linux-2.4.9/include/linux/sched.h linux/include/linux/sched.h
--- /usr/src/linux-2.4.9/include/linux/sched.h	Fri Aug 24 00:39:19 2001
+++ linux/include/linux/sched.h	Sun Aug 26 01:06:26 2001
@@ -401,6 +401,11 @@ struct task_struct {
    	u32 self_exec_id;
 /* Protection of (de-)allocation: mm, files, fs, tty */
 	spinlock_t alloc_lock;
+
+#if defined(CONFIG_AIO)
+	void *kaio_info;
+#endif
+
 };
 
 /*
diff -rupN /usr/src/linux-2.4.9/init/main.c linux/init/main.c
--- /usr/src/linux-2.4.9/init/main.c	Sat Jul 21 20:20:59 2001
+++ linux/init/main.c	Sat Aug 25 01:18:48 2001
@@ -590,6 +590,13 @@ asmlinkage void __init start_kernel(void
 #if defined(CONFIG_SYSVIPC)
 	ipc_init();
 #endif
+#if defined(CONFIG_AIO)
+	{
+		extern void kaio_init(void);
+
+		kaio_init();
+	}
+#endif
 	check_bugs();
 	printk("POSIX conformance testing by UNIFIX\n");
 
diff -rupN /usr/src/linux-2.4.9/kernel/exit.c linux/kernel/exit.c
--- /usr/src/linux-2.4.9/kernel/exit.c	Fri Aug 24 00:13:25 2001
+++ linux/kernel/exit.c	Sat Aug 25 01:18:48 2001
@@ -438,6 +438,13 @@ fake_volatile:
 #ifdef CONFIG_BSD_PROCESS_ACCT
 	acct_process(code);
 #endif
+#if defined(CONFIG_AIO)
+	if (tsk->kaio_info) {
+		extern void kaio_exit(void);
+
+		kaio_exit();
+	}
+#endif
 	__exit_mm(tsk);
 
 	lock_kernel();
diff -rupN /usr/src/linux-2.4.9/kernel/fork.c linux/kernel/fork.c
--- /usr/src/linux-2.4.9/kernel/fork.c	Sat Jul 21 20:20:59 2001
+++ linux/kernel/fork.c	Sat Aug 25 01:18:48 2001
@@ -680,6 +680,13 @@ int do_fork(unsigned long clone_flags, u
 	if (!current->counter)
 		current->need_resched = 1;
 
+#if defined(CONFIG_AIO)
+	if (current->kaio_info) {
+		extern int kaio_fork(struct task_struct *, int);
+
+		kaio_fork(p, clone_flags);
+	}
+#endif
 	/*
 	 * Ok, add it to the run-queues and make it
 	 * visible to the rest of the system.
diff -rupN /usr/src/linux-2.4.9/mm/filemap.c linux/mm/filemap.c
--- /usr/src/linux-2.4.9/mm/filemap.c	Fri Aug 24 00:13:25 2001
+++ linux/mm/filemap.c	Sun Aug 26 23:03:03 2001
@@ -2,6 +2,13 @@
  *	linux/mm/filemap.c
  *
  * Copyright (C) 1994-1999  Linus Torvalds
+ * 
+ * KAIO modifications:
+ * 	Copyright 1999, Silicon Graphics, Inc.
+ *
+ * 	Written October 1999 by Rajagopal Ananthanarayanan (ananth)
+ *                      at Silicon Graphics, Inc.
+ * 	With modifications suggested by Doug Rady at Silicon Graphics, Inc.
  */
 
 /*
@@ -29,6 +36,25 @@
 
 #include <linux/highmem.h>
 
+#if defined(CONFIG_AIO)
+#include <linux/aio.h>
+
+#ifdef AIO_DEBUG
+#define	assert(expression) { \
+	if (!(expression)) { \
+		(void)printk(KERN_ERR \
+			"assertion \"%s\" failed: file \"%s\", line %d\n", \
+			#expression, \
+			__FILE__, __LINE__); \
+	} \
+}
+#else
+#define assert(expresssion)
+#endif
+
+#define pageof(x)	(x >> PAGE_SHIFT)
+#endif /* CONFIG_AIO */
+
 /*
  * Shared mappings implemented 30.11.1994. It's not fully working yet,
  * though.
